//pYNX
//2002/06/20 22:12 by Tsukasa Jitoh
function TOZPuzzle()
{
	this.infoFieldName = null;
	this.komaFieldName = null;
	this.boardFieldName = null;
	this.map = null;
	this.boards = null;
	this.handCount = 0;
	this.bornKoma = 0;
	this.systemMode = 0;
	this.waitCount = 0;
	this.activeElement = null;
	this.activeElementColor = "";
	this.activeElementBgColor = "";

	//static data
/*
	this.displayChars = new Array("@","","","a","R","J");
	this.displayChars[10] = "";
	this.displayChars[20] = "";
	this.displayChars[30] = "O";
	this.displayChars[40] = "l";
	this.displayChars[50] = "";
	this.displayChars[60] = "Z";
	this.displayChars[91] = "";
	this.displayChars[92] = "";
	this.displayChars[93] = "O";
	this.displayChars[94] = "l";
	this.displayChars[95] = "";
	this.displayChars[96] = "Z";
*/
	this.displayColors = new Array(
		"white","#ddaa44","#0099FF","#009900","#996600","#996600");
	this.displayColors[10] = "#CC00FF";
	this.displayColors[20] = "orange";
	this.displayColors[30] = "#CCFF00";
	this.displayColors[40] = "#00FF33";
	this.displayColors[50] = "#66FFFF";
	this.displayColors[60] = "#55CCFF";
	this.displayColors[91] = "rightgray";
	this.displayColors[92] = "rightgray";
	this.displayColors[93] = "rightgray";
	this.displayColors[94] = "rightgray";
	this.displayColors[95] = "rightgray";
	this.displayColors[96] = "rightgray";
	this.displayImages = new Array(
		"images/none.png","images/nest.png","images/water.png",
		"images/food.png","images/mountain.png","images/libber.png");
	this.displayImages[10] = "images/1.png";
	this.displayImages[20] = "images/2.png";
	this.displayImages[30] = "images/3.png";
	this.displayImages[40] = "images/4.png";
	this.displayImages[50] = "images/5.png";
	this.displayImages[60] = "images/6.png";
	this.displayImages[91] = "images/d1.png";
	this.displayImages[92] = "images/d2.png";
	this.displayImages[93] = "images/d3.png";
	this.displayImages[94] = "images/d4.png";
	this.displayImages[95] = "images/d5.png";
	this.displayImages[96] = "images/d6.png";
	this.displayTitle = new Array("","","","a","R","J");
	this.displayTitle[10] = "1";
	this.displayTitle[20] = "2";
	this.displayTitle[30] = "3";
	this.displayTitle[40] = "4";
	this.displayTitle[50] = "5";
	this.displayTitle[60] = "6";
	this.displayTitle[91] = "_[N1";
	this.displayTitle[92] = "_[N2";
	this.displayTitle[93] = "_[N3";
	this.displayTitle[94] = "_[N4";
	this.displayTitle[95] = "_[N5";
	this.displayTitle[96] = "_[N6";

	//tB[hݒ
	this.setDrawfieldName = TOZPuzzle_setDrawfieldName;
	function TOZPuzzle_setDrawfieldName(infoFld, komaFld, boardFld)
	{
		this.infoFieldName = infoFld;
		this.komaFieldName = komaFld;
		this.boardFieldName = boardFld;
	}
	//}bvf[^CjVCY
	this.setMapData = TOZPuzzle_setMapData;
	function TOZPuzzle_setMapData(table)
	{
		this.map = table;
		this.handCount = 0;
		this.bornKoma = 0;
		this.systemMode = 0;
		this.boards = new Array();
		this.boards[this.handCount] = this.copyBoard(this.map.m);
	}
	//}bṽ݂{[hɕ
	this.copyBoard = TOZPuzzle_copyBoard;
	function TOZPuzzle_copyBoard(map)
	{
		var board = new Array();
		for(var y = 0; y < map.length; y++)
		{
			board[y] = new Array();
			for(var x = 0; x < map[y].length; x++)
				board[y][x] = map[y][x];
		}
		return board;
	}
	//pYŜ̕`
	this.draw = TOZPuzzle_draw;
	function TOZPuzzle_draw(infoFld, komaFld, boardFld)
	{
		this.drawInfo(infoFld);
		this.drawKoma(komaFld, this.displayChars, this.displayColors,
			this.displayImages, this.displayTitle);
		this.drawBoard(boardFld, this.displayChars, this.displayColors,
			this.displayImages, this.displayTitle);
	}
	//pY`
	this.drawInfo = TOZPuzzle_drawInfo;
	function TOZPuzzle_drawInfo(infoFld)
	{
		if(!infoFld)
			infoFld = this.infoFieldName;

		var s = "<div>mapF " + this.map.info + "</div>" +
			"<div>ݖF " + this.map.setsumon + "</div>";
		writeStr2Html(document, infoFld, s);
	}
	//`
	this.drawKoma = TOZPuzzle_drawKoma;
	function TOZPuzzle_drawKoma(komaFld, displayChars, displayColors,
		displayImages, displayTitle)
	{
		if(!komaFld)
			komaFld = this.komaFieldName;

		var s = "<div>";
		//
		var board = this.boards[this.handCount];
		var cntArr = new Array();
		for(var i = 0; i < this.map.successPtn.length; i++)
			cntArr[i] = 0;
		for(var y = 0; y < board.length; y++)
		{
			for(var x = 0; x < board[y].length; x++)
			{
				for(var i = 0; i < this.map.successPtn.length; i++)
				{
					if(board[y][x] == this.map.successPtn[i][0])
						cntArr[i]++;
				}
			}
		}
		var j = 0;
		for(var i = 0; i < this.map.successPtn.length; i++)
		{
			if(cntArr[i] >= this.map.successPtn[i][1])
				j++;
		}
		if(j == this.map.successPtn.length)
			s += "<br />߂łƂ! ł!!!";
		else if(this.handCount >= this.map.kaito.length)
		{
			s += this.handCount + "ŋȂȂ܂B";
			if(this.systemMode == 9)
				s += "<br />cOAs܂B";
		}
		else
		{
			s += (this.handCount + 1) + "ڂłBuĂ!<br />F";
			for(var i = this.handCount; i < this.map.kaito.length; i++)
			{
/* imageɕύX
				s += "<span class='littleitem' style='background-color:" +
					displayColors[this.map.kaito[i][0]] + "'>" +
					displayChars[this.map.kaito[i][0]] + "</span>";
*/
				s += "<span>" +
					"<img src='" + displayImages[this.map.kaito[i][0]] +
					"' title='" + displayTitle[this.map.kaito[i][0]] +
					"' width='30' height='30' border='1'></span>";
			}
		}

		s += "</div>";
		writeStr2Html(document, komaFld, s);
	}
	//`
	this.drawBoard = TOZPuzzle_drawBoard;
	function TOZPuzzle_drawBoard(boardFld, displayChars, displayColors,
		displayImages, displayTitle)
	{
		if(!boardFld)
			boardFld = this.boardFieldName;

		var s = "<table border='1'>";
		for(var y = 0; y < this.map.m.length; y++)
		{
			s += "<tr>\r\n";
			for(var x = 0; x < this.map.m[y].length; x++)
			{
/* imageɕύX
				s += "<td style='background-color:" +
					displayColors[this.boards[this.handCount][y][x]] +
					"'" +
					" onclick='clickItem(this," + y + "," + x + ")'" +
					" onmouseover='overItem(this," + y + "," + x + ")'" +
					" onmouseout='blurItem(this," + y + "," + x + ")'>" +
					"<span class='item' id='m" + y + "-" + x + "'>" +
					displayChars[this.boards[this.handCount][y][x]] +
					"</span></td>";
*/
				s += "<td style='background-color:" +
					displayColors[this.boards[this.handCount][y][x]] +
					"'" +
					" onclick='clickItem(this," + y + "," + x + ")'" +
					" onmouseover='overItem(this," + y + "," + x + ")'" +
					" onmouseout='blurItem(this," + y + "," + x + ")'>" +
					"<span id='m" + y + "-" + x + "'>" +
					"<img src='" +
					displayImages[this.boards[this.handCount][y][x]] +
					"' title='" +
					displayTitle[this.boards[this.handCount][y][x]] +
					"' width='40' height='40' class='item'></span></td>";
			}
			s += "\r\n</tr>\r\n";
		}

		writeStr2Html(document, boardFld, s);
	}
	//u
	this.putKoma = TOZPuzzle_putKoma;
	function TOZPuzzle_putKoma(y, x)
	{
		//ȂƉoȂ
		if((this.systemMode == 0 || this.systemMode == 2) &&
			this.handCount < this.map.kaito.length)
		{
			//ăGgubN
			this.systemMode = 1;

			//̃{[hAu
			var hand = this.handCount;
			this.boards[hand + 1] = this.copyBoard(this.boards[hand]);
			var beforKoma = this.boards[hand + 1][y][x];
			var newKoma = this.map.kaito[hand][0];
			if(isBurstKoma(this.boards[hand + 1][y][x], true))
			{
				var i = this.boards[hand + 1][y][x];
				if(newKoma == 1 && i == 1)
					newKoma = 4;
				else if((newKoma == 1 || newKoma > 2) && i > 2)
					newKoma = 1;
				this.boards[hand + 1][y][x] = newKoma;
			}
			//
			if(beforKoma > 2 && (newKoma == 1 || newKoma == 3))
			{
				if(y-1 >= 0)
				{
					if(isBurstKoma(this.boards[hand + 1][y-1][x]))
						this.boards[hand + 1][y-1][x] = 1;
				}
				if(x-1 >= 0)
				{
					if(isBurstKoma(this.boards[hand + 1][y][x-1]))
						this.boards[hand + 1][y][x-1] = 1;
				}
				if(x+1 < this.boards[hand + 1][y].length)
				{
					if(isBurstKoma(this.boards[hand + 1][y][x+1]))
						this.boards[hand + 1][y][x+1] = 1;
				}
				if(y+1 < this.boards[hand + 1].length)
				{
					if(isBurstKoma(this.boards[hand + 1][y+1][x]))
						this.boards[hand + 1][y+1][x] = 1;
				}
			}

			//i߂
			this.handCount++;

			//`
			this.draw();

			//C^[oԓZbg
			this.waitCount = 0;
			//`
			this.systemMode = 2;
		}
		//Burstł
		function isBurstKoma(koma, centerFlg)
		{
			return !((koma == 0 && !centerFlg) ||
				koma == 4 || (koma >= 91 && koma <= 96));
		}
	}
	//`
	this.computeBoard = TOZPuzzle_computeBoard;
	function TOZPuzzle_computeBoard()
	{
		this.systemMode++;
		var flag = false;
		var i;
		var board = this.boards[this.handCount];
		var newBoard = this.copyBoard(board);
		var yLim = board.length;

		//_[N]
		for(var y = 0; y < yLim; y++)
		{
			var xLim = board[y].length;
			for(var x = 0; x < xLim; x++)
			{
				i = board[y][x];
				if(i >= 91 && i <= 96 && this.bornKoma == (i - 90) * 10)
				{
					flag = true;
					newBoard[y][x] = (i - 90) * 10;
				}
			}
		}

		//ʏ
		if(!flag)
		{
			for(var y = 0; y < yLim; y++)
			{
				var xLim = board[y].length;
				for(var x = 0; x < xLim; x++)
				{
					if(board[y][x] == 1)
					{
						var data = new Array(0, 0, 0, 0);
						var koma = 0;

						//l̋擾
						if(y-1 >= 0)
							data[0] = board[y-1][x];
						if(x-1 >= 0)
							data[1] = board[y][x-1];
						if(x+1 < xLim)
							data[2] = board[y][x+1];
						if(y+1 < yLim)
							data[3] = board[y+1][x];

						//邩`FbN
						if(TOZPuzzle_getSameKoma(data, 50) > 1)
							koma = 60;
						else if((i = TOZPuzzle_getSameKoma(data, 40)) > 1)
							koma = 50 + (i - 2) * 10;
						else if((i = TOZPuzzle_getSameKoma(data, 30)) > 1)
							koma = 40 + (i - 2) * 10;
						else if((i = TOZPuzzle_getSameKoma(data, 20)) > 1)
							koma = 30 + (i - 2) * 10;
						else if((i = TOZPuzzle_getSameKoma(data, 10)) > 1)
							koma = 20 + (i - 2) * 10;
						else if(TOZPuzzle_getSameKoma(data, 2) > 0 &&
							TOZPuzzle_getSameKoma(data, 3) > 0)
							koma = 10;

						//]
						if(koma > 1)
						{
							flag = true;
							this.bornKoma = (koma > 60? 60 :koma);
							newBoard[y][x] = this.bornKoma;
						}
					}
				}
			}
		}
		if(flag)
		{
			//{[hXV
			this.boards[this.handCount] = newBoard;
			this.draw();
			this.systemMode--;
		}
		else
		{
			//IB[h߂A܂̓Q[I点B
			this.systemMode =
				(this.handCount < this.map.kaito.length? 0: 9);
			this.draw();
			//ĕ`ɐFXVȂ΍
			window.resizeBy(0, -1);
			window.resizeBy(0, 1);
		}
		//̌擾
		function TOZPuzzle_getSameKoma(data, code)
		{
			var rc = 0;
			for(var i = 0; i < 4; i++)
			{
				if(data[i] == code)
					rc++
			}
			return rc;
		}
	}
	//^C}[
	this.timerEvent = TOZPuzzle_timerEvent;
	function TOZPuzzle_timerEvent()
	{
		this.waitCount++;
		//C^[oԂ10{҂
		if(this.waitCount < 10)
			return;

		switch(this.systemMode)
		{
		case 2:
			this.computeBoard();
			break;
		}
		//C^[oԂZbg
		this.waitCount = 0;
	}
	//onmouseover event
	this.overItem = TOZPuzzle_overItem;
	function TOZPuzzle_overItem(elm, y, x)
	{
		if(this.systemMode != 0)
			return;

		var no = getAgentNo();
		if(no == 1 || no == 2)
		{
			this.activeElement = elm;
			this.activeElementBgColor = elm.style.backgroundColor;
			this.activeElementColor = elm.style.color;
			elm.style.backgroundColor = "lightgreen";
			elm.style.color = "white";
		}
	}
	//onmouseout event
	this.blurItem = TOZPuzzle_blurItem;
	function TOZPuzzle_blurItem(elm, y, x)
	{
		if(this.systemMode != 0 || this.activeElement != elm)
			return;

		var no = getAgentNo();
		if(no == 1 || no == 2)
		{
			elm.style.backgroundColor = this.activeElementBgColor;
			elm.style.color = this.activeElementColor;
		}
	}
}

